	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions	
	INCLUDE	i2c.inc		
	INCLUDE	bmp280.inc	
	EXPORT	main
	IMPORT	GPIO_setup		; import names from other code files
	IMPORT	LETIMER_setup	
	IMPORT	I2C1_setup	
		
	IMPORT	temp
	IMPORT	press	
;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication
	bl	GPIO_setup		; configure port pins
	bl	LETIMER_setup
	bl	I2C1_setup
	
	OORW	4<<4, GPIO_PF_MODEH, GPIO	; enable power to ENV sensors
	OORW	1<<9, GPIO_PF_DOUT
	bl	BMP280_setup			; setup sensor parameters
	bl	BMP280_read_calib		; read calibration coefficients	
	bl	BMP280_request_conversion
	
loop					
	wfi
	bl	BMP280_read_data		; read sensor data
	bl	BMP280_request_conversion	; request new conversion
	bl	BMP280_compute_values		; convert raw sensor values
	bl	print_Values
	b	loop				
	ENDP

;--------------------------------------
print_Values	PROC
	push	{LR, R0}	
	ldr	R0, =pT1
	bl	WriteString
	ldr	R0, =temp
	ldr	R1, [R0]		; R1 = temp*100
	mov	R2, #100
	udiv	R0, R1, R2
	bl	WriteInt		; print temperature (int. part)
	push	{R0}
	mov	R0, #'.'
	bl	WriteChar
	pop	{R0}
	mls	R0, R0, R2, R1		
	bl	WriteInt		; print temperature (frac. part)	
	ldr	R0, =pT2
	bl	WriteString		; print units of temp
	
	ldr	R0, =press
	ldr	R0, [R0]
	add	R1, R0, R0, LSL #1	; R1 = press*3
	bl	WriteInt		; print pressure in Pa
	ldr	R0, =pT3
	bl	WriteString
	
	mov	R2, #400		; convert pressure into mmHg
	udiv	R0, R1, R2
	bl	WriteInt
	ldr	R0, =pT4
	bl	WriteString
	pop	{PC, R0}
	ENDP
		
;--------------------------------------
pT1	DCB	"Temp = ", 0
pT2	DCB	' ', 176, "C    Pressure = ", 0
pT3	DCB	" Pa   = ", 0
pT4	DCB	" mmHg",13, 10, 0
	ALIGN
	END